diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajbg.h ./win32/dependencies/cximage/ximajbg.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajbg.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximajbg.h	2006-08-24 07:16:03 +0900
@@ -0,0 +1,44 @@
+/*
+ * File:	ximajbg.h
+ * Purpose:	JBG Image Class Loader and Writer
+ */
+/* ==========================================================
+ * CxImageJBG (c) 18/Aug/2002 Davide Pizzolato - www.xdp.it
+ * For conditions of distribution and use, see copyright notice in ximage.h
+ *
+ * based on LIBJBG Copyright (c) 2002, Markus Kuhn - All rights reserved.
+ * ==========================================================
+ */
+#if !defined(__ximaJBG_h)
+#define __ximaJBG_h
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_JBG
+
+extern "C" {
+#include "../jbig/jbig.h"
+};
+
+class CxImageJBG: public CxImage
+{
+public:
+	CxImageJBG(): CxImage(CXIMAGE_FORMAT_JBG) {}
+
+//	bool Load(const char * imageFileName){ return CxImage::Load(imageFileName,CXIMAGE_FORMAT_JBG);}
+//	bool Save(const char * imageFileName){ return CxImage::Save(imageFileName,CXIMAGE_FORMAT_JBG);}
+	bool Decode(CxFile * hFile);
+	bool Decode(FILE *hFile) { CxIOFile file(hFile); return Decode(&file); }
+
+#if CXIMAGE_SUPPORT_ENCODE
+	bool Encode(CxFile * hFile);
+	bool Encode(FILE *hFile) { CxIOFile file(hFile); return Encode(&file); }
+#endif // CXIMAGE_SUPPORT_ENCODE
+protected:
+	static void jbig_data_out(BYTE *buffer, unsigned int len, void *file)
+							{((CxFile*)file)->Write(buffer,len,1);}
+};
+
+#endif
+
+#endif
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajpg.cpp ./win32/dependencies/cximage/ximajpg.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajpg.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximajpg.cpp	2006-08-24 07:16:03 +0900
@@ -0,0 +1,454 @@
+/*
+ * File:	ximajpg.cpp
+ * Purpose:	Platform Independent JPEG Image Class Loader and Writer
+ * 07/Aug/2001 Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+ 
+#include "ximajpg.h"
+
+#if CXIMAGE_SUPPORT_JPG
+
+#include "../jpeg/jmorecfg.h"
+
+#include "ximaiter.h"
+         
+#include <setjmp.h>
+
+struct jpg_error_mgr {
+	struct jpeg_error_mgr pub;	/* "public" fields */
+	jmp_buf setjmp_buffer;		/* for return to caller */
+	char* buffer;				/* error message <CSC>*/
+};
+typedef jpg_error_mgr *jpg_error_ptr;
+
+////////////////////////////////////////////////////////////////////////////////
+// Here's the routine that will replace the standard error_exit method:
+////////////////////////////////////////////////////////////////////////////////
+static void
+ima_jpeg_error_exit (j_common_ptr cinfo)
+{
+	/* cinfo->err really points to a my_error_mgr struct, so coerce pointer */
+	jpg_error_ptr myerr = (jpg_error_ptr) cinfo->err;
+	/* Create the message */
+	myerr->pub.format_message (cinfo, myerr->buffer);
+	/* Send it to stderr, adding a newline */
+	/* Return control to the setjmp point */
+	longjmp(myerr->setjmp_buffer, 1);
+}
+////////////////////////////////////////////////////////////////////////////////
+CxImageJPG::CxImageJPG(): CxImage(CXIMAGE_FORMAT_JPG)
+{
+#if CXIMAGEJPG_SUPPORT_EXIF
+	m_exif = NULL;
+	memset(&m_exifinfo, 0, sizeof(EXIFINFO));
+#endif
+}
+////////////////////////////////////////////////////////////////////////////////
+CxImageJPG::~CxImageJPG()
+{
+#if CXIMAGEJPG_SUPPORT_EXIF
+	if (m_exif) delete m_exif;
+#endif
+}
+////////////////////////////////////////////////////////////////////////////////
+#if CXIMAGEJPG_SUPPORT_EXIF
+bool CxImageJPG::DecodeExif(CxFile * hFile)
+{
+	m_exif = new CxExifInfo(&m_exifinfo);
+	if (m_exif){
+		long pos=hFile->Tell();
+		m_exif->DecodeExif(hFile);
+		hFile->Seek(pos,SEEK_SET);
+		return m_exif->m_exifinfo->IsExif;
+	} else {
+		return false;
+	}
+}
+#endif //CXIMAGEJPG_SUPPORT_EXIF
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageJPG::Decode(CxFile * hFile)
+{
+
+	bool is_exif = false;
+#if CXIMAGEJPG_SUPPORT_EXIF
+	is_exif = DecodeExif(hFile);
+#endif
+
+	CImageIterator iter(this);
+	/* This struct contains the JPEG decompression parameters and pointers to
+	* working space (which is allocated as needed by the JPEG library).
+	*/
+	struct jpeg_decompress_struct cinfo;
+	/* We use our private extension JPEG error handler. <CSC> */
+	struct jpg_error_mgr jerr;
+	jerr.buffer=info.szLastError;
+	/* More stuff */
+	JSAMPARRAY buffer;	/* Output row buffer */
+	int row_stride;		/* physical row width in output buffer */
+
+	/* In this example we want to open the input file before doing anything else,
+	* so that the setjmp() error recovery below can assume the file is open.
+	* VERY IMPORTANT: use "b" option to fopen() if you are on a machine that
+	* requires it in order to read binary files.
+	*/
+
+	/* Step 1: allocate and initialize JPEG decompression object */
+	/* We set up the normal JPEG error routines, then override error_exit. */
+	cinfo.err = jpeg_std_error(&jerr.pub);
+	jerr.pub.error_exit = ima_jpeg_error_exit;
+
+	/* Establish the setjmp return context for my_error_exit to use. */
+	if (setjmp(jerr.setjmp_buffer)) {
+		/* If we get here, the JPEG code has signaled an error.
+		* We need to clean up the JPEG object, close the input file, and return.
+		*/
+		jpeg_destroy_decompress(&cinfo);
+		return 0;
+	}
+	/* Now we can initialize the JPEG decompression object. */
+	jpeg_create_decompress(&cinfo);
+
+	/* Step 2: specify data source (eg, a file) */
+	//jpeg_stdio_src(&cinfo, infile);
+	CxFileJpg src(hFile);
+    cinfo.src = &src;
+
+	/* Step 3: read file parameters with jpeg_read_header() */
+	(void) jpeg_read_header(&cinfo, TRUE);
+
+	/* Step 4 <chupeev> handle decoder options*/
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & DECODE_GRAYSCALE) != 0)
+		cinfo.out_color_space = JCS_GRAYSCALE;
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & DECODE_QUANTIZE) != 0) {
+		cinfo.quantize_colors = TRUE;
+		cinfo.desired_number_of_colors = info.nQuality;
+	}
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & DECODE_DITHER) != 0)
+		cinfo.dither_mode = m_nDither;
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & DECODE_ONEPASS) != 0)
+		cinfo.two_pass_quantize = FALSE;
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & DECODE_NOSMOOTH) != 0)
+		cinfo.do_fancy_upsampling = FALSE;
+
+//<DP>: Load true color images as RGB (no quantize) 
+/* Step 4: set parameters for decompression */
+/*  if (cinfo.jpeg_color_space!=JCS_GRAYSCALE) {
+ *	cinfo.quantize_colors = TRUE;
+ *	cinfo.desired_number_of_colors = 128;
+ *}
+ */ //</DP>
+
+	// Set the scale <ignacio>
+	cinfo.scale_denom = GetJpegScale();
+
+	// Borrowed the idea from GIF implementation <ignacio>
+	if (info.nEscape == -1) {
+		// Return output dimensions only
+		jpeg_calc_output_dimensions(&cinfo);
+		head.biWidth = cinfo.output_width;
+		head.biHeight = cinfo.output_height;
+		jpeg_destroy_decompress(&cinfo);
+		return true;
+	}
+
+	/* Step 5: Start decompressor */
+	jpeg_start_decompress(&cinfo);
+
+	/* We may need to do some setup of our own at this point before reading
+	* the data.  After jpeg_start_decompress() we have the correct scaled
+	* output image dimensions available, as well as the output colormap
+	* if we asked for color quantization.
+	*/
+	//Create the image using output dimensions <ignacio>
+	//Create(cinfo.image_width, cinfo.image_height, 8*cinfo.output_components, CXIMAGE_FORMAT_JPG);
+	Create(cinfo.output_width, cinfo.output_height, 8*cinfo.output_components, CXIMAGE_FORMAT_JPG);
+
+	if (!pDib) longjmp(jerr.setjmp_buffer, 1);  //<DP> check if the image has been created
+
+	if (is_exif){
+#if CXIMAGEJPG_SUPPORT_EXIF
+	if ((m_exifinfo.Xresolution != 0.0) && (m_exifinfo.ResolutionUnit != 0))
+		SetXDPI((long)(m_exifinfo.Xresolution/m_exifinfo.ResolutionUnit));
+	if ((m_exifinfo.Yresolution != 0.0) && (m_exifinfo.ResolutionUnit != 0))
+		SetYDPI((long)(m_exifinfo.Yresolution/m_exifinfo.ResolutionUnit));
+#endif
+	} else {
+		if (cinfo.density_unit==2){
+			SetXDPI((long)floor(cinfo.X_density * 254.0 / 10000.0 + 0.5));
+			SetYDPI((long)floor(cinfo.Y_density * 254.0 / 10000.0 + 0.5));
+		} else {
+			SetXDPI(cinfo.X_density);
+			SetYDPI(cinfo.Y_density);
+		}
+	}
+
+	if (cinfo.out_color_space==JCS_GRAYSCALE){
+		SetGrayPalette();
+		head.biClrUsed =256;
+	} else {
+		if (cinfo.quantize_colors==TRUE){
+			SetPalette(cinfo.actual_number_of_colors, cinfo.colormap[0], cinfo.colormap[1], cinfo.colormap[2]);
+			head.biClrUsed=cinfo.actual_number_of_colors;
+		} else {
+			head.biClrUsed=0;
+		}
+	}
+
+	/* JSAMPLEs per row in output buffer */
+	row_stride = cinfo.output_width * cinfo.output_components;
+
+	/* Make a one-row-high sample array that will go away when done with image */
+	buffer = (*cinfo.mem->alloc_sarray)
+		((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);
+
+	/* Step 6: while (scan lines remain to be read) */
+	/*           jpeg_read_scanlines(...); */
+	/* Here we use the library's state variable cinfo.output_scanline as the
+	* loop counter, so that we don't have to keep track ourselves.
+	*/
+	iter.Upset();
+	while (cinfo.output_scanline < cinfo.output_height) {
+
+		if (info.nEscape) longjmp(jerr.setjmp_buffer, 1); // <vho> - cancel decoding
+		
+		(void) jpeg_read_scanlines(&cinfo, buffer, 1);
+		// info.nProgress = (long)(100*cinfo.output_scanline/cinfo.output_height);
+		//<DP> Step 6a: CMYK->RGB */ 
+		if ((cinfo.num_components==4)&&(cinfo.quantize_colors==FALSE)){
+			BYTE k,*dst,*src;
+			dst=iter.GetRow();
+			src=buffer[0];
+			for(long x3=0,x4=0; x3<(long)info.dwEffWidth && x4<row_stride; x3+=3, x4+=4){
+				k=src[x4+3];
+				dst[x3]  =(BYTE)((k * src[x4+2])/255);
+				dst[x3+1]=(BYTE)((k * src[x4+1])/255);
+				dst[x3+2]=(BYTE)((k * src[x4+0])/255);
+			}
+		} else {
+			/* Assume put_scanline_someplace wants a pointer and sample count. */
+			iter.SetRow(buffer[0], row_stride);
+		}
+			iter.PrevRow();
+	}
+
+	/* Step 7: Finish decompression */
+	(void) jpeg_finish_decompress(&cinfo);
+	/* We can ignore the return value since suspension is not possible
+	* with the stdio data source.
+	*/
+
+	//<DP> Step 7A: Swap red and blue components
+	// not necessary if swapped red and blue definition in jmorecfg.h;ln322 <W. Morrison>
+	if ((cinfo.num_components==3)&&(cinfo.quantize_colors==FALSE)){
+		BYTE* r0=GetBits();
+		for(long y=0;y<head.biHeight;y++){
+			if (info.nEscape) longjmp(jerr.setjmp_buffer, 1); // <vho> - cancel decoding
+			RGBtoBGR(r0,3*head.biWidth);
+			r0+=info.dwEffWidth;
+		}
+	}
+
+	/* Step 8: Release JPEG decompression object */
+	/* This is an important step since it will release a good deal of memory. */
+	jpeg_destroy_decompress(&cinfo);
+
+	/* At this point you may want to check to see whether any corrupt-data
+	* warnings occurred (test whether jerr.pub.num_warnings is nonzero).
+	*/
+
+	/* And we're done! */
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#if CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageJPG::Encode(CxFile * hFile)
+{
+	if (EncodeSafeCheck(hFile)) return false;
+
+	if (head.biClrUsed!=0 && !IsGrayScale()){
+		strcpy(info.szLastError,"JPEG can save only RGB or GreyScale images");
+		return false;
+	}	
+
+	// necessary for EXIF, and for roll backs
+	long pos=hFile->Tell();
+
+	/* This struct contains the JPEG compression parameters and pointers to
+	* working space (which is allocated as needed by the JPEG library).
+	* It is possible to have several such structures, representing multiple
+	* compression/decompression processes, in existence at once.  We refer
+	* to any one struct (and its associated working data) as a "JPEG object".
+	*/
+	struct jpeg_compress_struct cinfo;
+	/* This struct represents a JPEG error handler.  It is declared separately
+	* because applications often want to supply a specialized error handler
+	* (see the second half of this file for an example).  But here we just
+	* take the easy way out and use the standard error handler, which will
+	* print a message on stderr and call exit() if compression fails.
+	* Note that this struct must live as long as the main JPEG parameter
+	* struct, to avoid dangling-pointer problems.
+	*/
+	//struct jpeg_error_mgr jerr;
+	/* We use our private extension JPEG error handler. <CSC> */
+	struct jpg_error_mgr jerr;
+	jerr.buffer=info.szLastError;
+	/* More stuff */
+	int row_stride;		/* physical row width in image buffer */
+	JSAMPARRAY buffer;		/* Output row buffer */
+
+	/* Step 1: allocate and initialize JPEG compression object */
+	/* We have to set up the error handler first, in case the initialization
+	* step fails.  (Unlikely, but it could happen if you are out of memory.)
+	* This routine fills in the contents of struct jerr, and returns jerr's
+	* address which we place into the link field in cinfo.
+	*/
+	//cinfo.err = jpeg_std_error(&jerr); <CSC>
+	/* We set up the normal JPEG error routines, then override error_exit. */
+	cinfo.err = jpeg_std_error(&jerr.pub);
+	jerr.pub.error_exit = ima_jpeg_error_exit;
+
+	/* Establish the setjmp return context for my_error_exit to use. */
+	if (setjmp(jerr.setjmp_buffer)) {
+		/* If we get here, the JPEG code has signaled an error.
+		* We need to clean up the JPEG object, close the input file, and return.
+		*/
+		strcpy(info.szLastError, jerr.buffer); //<CSC>
+		jpeg_destroy_compress(&cinfo);
+		return 0;
+	}
+	
+	/* Now we can initialize the JPEG compression object. */
+	jpeg_create_compress(&cinfo);
+	/* Step 2: specify data destination (eg, a file) */
+	/* Note: steps 2 and 3 can be done in either order. */
+	/* Here we use the library-supplied code to send compressed data to a
+	* stdio stream.  You can also write your own code to do something else.
+	* VERY IMPORTANT: use "b" option to fopen() if you are on a machine that
+	* requires it in order to write binary files.
+	*/
+
+	//jpeg_stdio_dest(&cinfo, outfile);
+	CxFileJpg dest(hFile);
+    cinfo.dest = &dest;
+
+	/* Step 3: set parameters for compression */
+	/* First we supply a description of the input image.
+	* Four fields of the cinfo struct must be filled in:
+	*/
+	cinfo.image_width = GetWidth(); 	// image width and height, in pixels
+	cinfo.image_height = GetHeight();
+
+	if (IsGrayScale()){
+		cinfo.input_components = 1;			// # of color components per pixel
+		cinfo.in_color_space = JCS_GRAYSCALE; /* colorspace of input image */
+	} else {
+		cinfo.input_components = 3; 	// # of color components per pixel
+		cinfo.in_color_space = JCS_RGB; /* colorspace of input image */
+	}
+
+	/* Now use the library's routine to set default compression parameters.
+	* (You must set at least cinfo.in_color_space before calling this,
+	* since the defaults depend on the source color space.)
+	*/
+	jpeg_set_defaults(&cinfo);
+	/* Now you can set any non-default parameters you wish to.
+	* Here we just illustrate the use of quality (quantization table) scaling:
+	*/
+
+//#ifdef C_ARITH_CODING_SUPPORTED
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & ENCODE_ARITHMETIC) != 0)
+		cinfo.arith_code = TRUE;
+//#endif
+
+//#ifdef ENTROPY_OPT_SUPPORTED
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & ENCODE_OPTIMIZE) != 0)
+		cinfo.optimize_coding = TRUE;
+//#endif
+
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & ENCODE_GRAYSCALE) != 0)
+		jpeg_set_colorspace(&cinfo, JCS_GRAYSCALE);
+
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & ENCODE_SMOOTHING) != 0)
+		cinfo.smoothing_factor = m_nSmoothing;
+
+	jpeg_set_quality(&cinfo, GetJpegQuality(), (GetCodecOption(CXIMAGE_FORMAT_JPG) & ENCODE_BASELINE) != 0);
+
+//#ifdef C_PROGRESSIVE_SUPPORTED
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & ENCODE_PROGRESSIVE) != 0)
+		jpeg_simple_progression(&cinfo);
+//#endif
+
+#ifdef C_LOSSLESS_SUPPORTED
+	if ((GetCodecOption(CXIMAGE_FORMAT_JPG) & ENCODE_LOSSLESS) != 0)
+		jpeg_simple_lossless(&cinfo, m_nPredictor, m_nPointTransform);
+#endif
+
+	cinfo.density_unit=1;
+	cinfo.X_density=(unsigned short)GetXDPI();
+	cinfo.Y_density=(unsigned short)GetYDPI();
+
+	/* Step 4: Start compressor */
+	/* TRUE ensures that we will write a complete interchange-JPEG file.
+	* Pass TRUE unless you are very sure of what you're doing.
+	*/
+	jpeg_start_compress(&cinfo, TRUE);
+
+	/* Step 5: while (scan lines remain to be written) */
+	/*           jpeg_write_scanlines(...); */
+	/* Here we use the library's state variable cinfo.next_scanline as the
+	* loop counter, so that we don't have to keep track ourselves.
+	* To keep things simple, we pass one scanline per call; you can pass
+	* more if you wish, though.
+	*/
+	row_stride = info.dwEffWidth;	/* JSAMPLEs per row in image_buffer */
+
+	//<DP> "8+row_stride" fix heap deallocation problem during debug???
+	buffer = (*cinfo.mem->alloc_sarray)
+		((j_common_ptr) &cinfo, JPOOL_IMAGE, 8+row_stride, 1);
+
+	CImageIterator iter(this);
+
+	iter.Upset();
+	while (cinfo.next_scanline < cinfo.image_height) {
+		// info.nProgress = (long)(100*cinfo.next_scanline/cinfo.image_height);
+		iter.GetRow(buffer[0], row_stride);
+		// not necessary if swapped red and blue definition in jmorecfg.h;ln322 <W. Morrison>
+		if (head.biClrUsed==0){				 // swap R & B for RGB images
+			RGBtoBGR(buffer[0], row_stride); // Lance : 1998/09/01 : Bug ID: EXP-2.1.1-9
+		}
+		iter.PrevRow();
+		(void) jpeg_write_scanlines(&cinfo, buffer, 1);
+	}
+
+	/* Step 6: Finish compression */
+	jpeg_finish_compress(&cinfo);
+
+	/* Step 7: release JPEG compression object */
+	/* This is an important step since it will release a good deal of memory. */
+	jpeg_destroy_compress(&cinfo);
+
+
+#if CXIMAGEJPG_SUPPORT_EXIF
+	if (m_exif && m_exif->m_exifinfo->IsExif){
+		// discard useless sections (if any) read from original image
+		m_exif->DiscardAllButExif();
+		// read new created image, to split the sections
+		hFile->Seek(pos,SEEK_SET);
+		m_exif->DecodeExif(hFile,EXIF_READ_IMAGE);
+		// save back the image, adding EXIF section
+		hFile->Seek(pos,SEEK_SET);
+		m_exif->EncodeExif(hFile);
+	}
+#endif
+
+
+	/* And we're done! */
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif // CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+#endif // CXIMAGE_SUPPORT_JPG
+
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajpg.h ./win32/dependencies/cximage/ximajpg.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximajpg.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximajpg.h	2006-08-24 07:16:03 +0900
@@ -0,0 +1,315 @@
+/*
+ * File:	ximajpg.h
+ * Purpose:	JPG Image Class Loader and Writer
+ */
+/* ==========================================================
+ * CxImageJPG (c) 07/Aug/2001 Davide Pizzolato - www.xdp.it
+ * For conditions of distribution and use, see copyright notice in ximage.h
+ *
+ * Special thanks to Troels Knakkergaard for new features, enhancements and bugfixes
+ *
+ * Special thanks to Chris Shearer Cooper for CxFileJpg tips & code
+ *
+ * EXIF support based on jhead-1.8 by Matthias Wandel <mwandel(at)rim(dot)net>
+ *
+ * original CImageJPG  and CImageIterator implementation are:
+ * Copyright:	(c) 1995, Alejandro Aguilar Sierra <asierra(at)servidor(dot)unam(dot)mx>
+ *
+ * This software is based in part on the work of the Independent JPEG Group.
+ * Copyright (C) 1991-1998, Thomas G. Lane.
+ * ==========================================================
+ */
+#if !defined(__ximaJPEG_h)
+#define __ixmaJPEG_h
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_JPG
+
+#define CXIMAGEJPG_SUPPORT_EXIF 1
+
+extern "C" {
+ #include "../jpeg/jpeglib.h"
+ #include "../jpeg/jerror.h"
+}
+
+class DLL_EXP CxImageJPG: public CxImage
+{
+public:
+	CxImageJPG();
+	~CxImageJPG();
+
+//	bool Load(const char * imageFileName){ return CxImage::Load(imageFileName,CXIMAGE_FORMAT_JPG);}
+//	bool Save(const char * imageFileName){ return CxImage::Save(imageFileName,CXIMAGE_FORMAT_JPG);}
+	bool Decode(CxFile * hFile);
+	bool Decode(FILE *hFile) { CxIOFile file(hFile); return Decode(&file); }
+
+#if CXIMAGE_SUPPORT_ENCODE
+	bool Encode(CxFile * hFile);
+	bool Encode(FILE *hFile) { CxIOFile file(hFile); return Encode(&file); }
+#endif // CXIMAGE_SUPPORT_ENCODE
+
+/*
+ * EXIF support based on jhead-1.8 by Matthias Wandel <mwandel(at)rim(dot)net>
+ */
+
+#if CXIMAGEJPG_SUPPORT_EXIF
+
+#define MAX_COMMENT 1000
+#define MAX_SECTIONS 20
+
+typedef struct tag_ExifInfo {
+	char  Version      [5];
+    char  CameraMake   [32];
+    char  CameraModel  [40];
+    char  DateTime     [20];
+    int   Height, Width;
+    int   Orientation;
+    int   IsColor;
+    int   Process;
+    int   FlashUsed;
+    float FocalLength;
+    float ExposureTime;
+    float ApertureFNumber;
+    float Distance;
+    float CCDWidth;
+    float ExposureBias;
+    int   Whitebalance;
+    int   MeteringMode;
+    int   ExposureProgram;
+    int   ISOequivalent;
+    int   CompressionLevel;
+	float FocalplaneXRes;
+	float FocalplaneYRes;
+	float FocalplaneUnits;
+	float Xresolution;
+	float Yresolution;
+	float ResolutionUnit;
+	float Brightness;
+    char  Comments[MAX_COMMENT];
+
+    unsigned char * ThumbnailPointer;  /* Pointer at the thumbnail */
+    unsigned ThumbnailSize;     /* Size of thumbnail. */
+
+	bool  IsExif;
+} EXIFINFO;
+
+//--------------------------------------------------------------------------
+// JPEG markers consist of one or more 0xFF bytes, followed by a marker
+// code byte (which is not an FF).  Here are the marker codes of interest
+// in this program.  (See jdmarker.c for a more complete list.)
+//--------------------------------------------------------------------------
+
+#define M_SOF0  0xC0            // Start Of Frame N
+#define M_SOF1  0xC1            // N indicates which compression process
+#define M_SOF2  0xC2            // Only SOF0-SOF2 are now in common use
+#define M_SOF3  0xC3
+#define M_SOF5  0xC5            // NB: codes C4 and CC are NOT SOF markers
+#define M_SOF6  0xC6
+#define M_SOF7  0xC7
+#define M_SOF9  0xC9
+#define M_SOF10 0xCA
+#define M_SOF11 0xCB
+#define M_SOF13 0xCD
+#define M_SOF14 0xCE
+#define M_SOF15 0xCF
+#define M_SOI   0xD8            // Start Of Image (beginning of datastream)
+#define M_EOI   0xD9            // End Of Image (end of datastream)
+#define M_SOS   0xDA            // Start Of Scan (begins compressed data)
+#define M_JFIF  0xE0            // Jfif marker
+#define M_EXIF  0xE1            // Exif marker
+#define M_COM   0xFE            // COMment 
+
+#define PSEUDO_IMAGE_MARKER 0x123; // Extra value.
+
+#define EXIF_READ_EXIF  0x01
+#define EXIF_READ_IMAGE 0x02
+#define EXIF_READ_ALL   0x03
+
+class DLL_EXP CxExifInfo
+{
+
+typedef struct tag_Section_t{
+    BYTE*    Data;
+    int      Type;
+    unsigned Size;
+} Section_t;
+
+public:
+	EXIFINFO* m_exifinfo;
+	char m_szLastError[256];
+	CxExifInfo(EXIFINFO* info = NULL);
+	~CxExifInfo();
+	bool DecodeExif(CxFile * hFile, int nReadMode = EXIF_READ_EXIF);
+	bool EncodeExif(CxFile * hFile);
+	void DiscardAllButExif();
+protected:
+	bool process_EXIF(unsigned char * CharBuf, unsigned int length);
+	void process_COM (const BYTE * Data, int length);
+	void process_SOFn (const BYTE * Data, int marker);
+	int Get16u(void * Short);
+	int Get16m(void * Short);
+	long Get32s(void * Long);
+	unsigned long Get32u(void * Long);
+	double ConvertAnyFormat(void * ValuePtr, int Format);
+	void* FindSection(int SectionType);
+	bool ProcessExifDir(unsigned char * DirStart, unsigned char * OffsetBase, unsigned ExifLength,
+                           EXIFINFO * const pInfo, unsigned char ** const LastExifRefdP);
+	int ExifImageWidth;
+	int MotorolaOrder;
+	Section_t Sections[MAX_SECTIONS];
+	int SectionsRead;
+	bool freeinfo;
+};
+
+	CxExifInfo* m_exif;
+	EXIFINFO m_exifinfo;
+	bool DecodeExif(CxFile * hFile);
+	bool DecodeExif(FILE * hFile) { CxIOFile file(hFile); return DecodeExif(&file); }
+
+#endif //CXIMAGEJPG_SUPPORT_EXIF
+
+////////////////////////////////////////////////////////////////////////////////////////
+//////////////////////        C x F i l e J p g         ////////////////////////////////
+////////////////////////////////////////////////////////////////////////////////////////
+
+// thanks to Chris Shearer Cooper <cscooper(at)frii(dot)com>
+class CxFileJpg : public jpeg_destination_mgr, public jpeg_source_mgr
+	{
+public:
+	enum { eBufSize = 4096 };
+
+	CxFileJpg(CxFile* pFile)
+	{
+        m_pFile = pFile;
+
+		init_destination = InitDestination;
+		empty_output_buffer = EmptyOutputBuffer;
+		term_destination = TermDestination;
+
+		init_source = InitSource;
+		fill_input_buffer = FillInputBuffer;
+		skip_input_data = SkipInputData;
+		resync_to_restart = jpeg_resync_to_restart; // use default method
+		term_source = TermSource;
+		next_input_byte = NULL; //* => next byte to read from buffer 
+		bytes_in_buffer = 0;	//* # of bytes remaining in buffer 
+
+		m_pBuffer = new unsigned char[eBufSize];
+	}
+	~CxFileJpg()
+	{
+		delete [] m_pBuffer;
+	}
+
+	static void InitDestination(j_compress_ptr cinfo)
+	{
+		CxFileJpg* pDest = (CxFileJpg*)cinfo->dest;
+		pDest->next_output_byte = pDest->m_pBuffer;
+		pDest->free_in_buffer = eBufSize;
+	}
+
+	static boolean EmptyOutputBuffer(j_compress_ptr cinfo)
+	{
+		CxFileJpg* pDest = (CxFileJpg*)cinfo->dest;
+		if (pDest->m_pFile->Write(pDest->m_pBuffer,1,eBufSize)!=(size_t)eBufSize)
+			ERREXIT(cinfo, JERR_FILE_WRITE);
+		pDest->next_output_byte = pDest->m_pBuffer;
+		pDest->free_in_buffer = eBufSize;
+		return TRUE;
+	}
+
+	static void TermDestination(j_compress_ptr cinfo)
+	{
+		CxFileJpg* pDest = (CxFileJpg*)cinfo->dest;
+		size_t datacount = eBufSize - pDest->free_in_buffer;
+		/* Write any data remaining in the buffer */
+		if (datacount > 0) {
+			if (!pDest->m_pFile->Write(pDest->m_pBuffer,1,datacount))
+				ERREXIT(cinfo, JERR_FILE_WRITE);
+		}
+		pDest->m_pFile->Flush();
+		/* Make sure we wrote the output file OK */
+		if (pDest->m_pFile->Error()) ERREXIT(cinfo, JERR_FILE_WRITE);
+		return;
+	}
+
+	static void InitSource(j_decompress_ptr cinfo)
+	{
+		CxFileJpg* pSource = (CxFileJpg*)cinfo->src;
+		pSource->m_bStartOfFile = TRUE;
+	}
+
+	static boolean FillInputBuffer(j_decompress_ptr cinfo)
+	{
+		size_t nbytes;
+		CxFileJpg* pSource = (CxFileJpg*)cinfo->src;
+		nbytes = pSource->m_pFile->Read(pSource->m_pBuffer,1,eBufSize);
+		if (nbytes <= 0){
+			if (pSource->m_bStartOfFile)	//* Treat empty input file as fatal error 
+				ERREXIT(cinfo, JERR_INPUT_EMPTY);
+			WARNMS(cinfo, JWRN_JPEG_EOF);
+			// Insert a fake EOI marker 
+			pSource->m_pBuffer[0] = (JOCTET) 0xFF;
+			pSource->m_pBuffer[1] = (JOCTET) JPEG_EOI;
+			nbytes = 2;
+		}
+		pSource->next_input_byte = pSource->m_pBuffer;
+		pSource->bytes_in_buffer = nbytes;
+		pSource->m_bStartOfFile = FALSE;
+		return TRUE;
+	}
+
+	static void SkipInputData(j_decompress_ptr cinfo, long num_bytes)
+	{
+		CxFileJpg* pSource = (CxFileJpg*)cinfo->src;
+		if (num_bytes > 0){
+			while (num_bytes > (long)pSource->bytes_in_buffer){
+				num_bytes -= (long)pSource->bytes_in_buffer;
+				FillInputBuffer(cinfo);
+				// note we assume that fill_input_buffer will never return FALSE,
+				// so suspension need not be handled.
+			}
+			pSource->next_input_byte += (size_t) num_bytes;
+			pSource->bytes_in_buffer -= (size_t) num_bytes;
+		}
+	}
+
+	static void TermSource(j_decompress_ptr cinfo)
+	{
+		return;
+	}
+protected:
+    CxFile  *m_pFile;
+	unsigned char *m_pBuffer;
+	bool m_bStartOfFile;
+};
+
+public:
+	enum CODEC_OPTION
+	{
+		ENCODE_BASELINE = 0x1,
+		ENCODE_ARITHMETIC = 0x2,
+		ENCODE_GRAYSCALE = 0x4,
+		ENCODE_OPTIMIZE = 0x8,
+		ENCODE_PROGRESSIVE = 0x10,
+		ENCODE_LOSSLESS = 0x20,
+		ENCODE_SMOOTHING = 0x40,
+		DECODE_GRAYSCALE = 0x80,
+		DECODE_QUANTIZE = 0x100,
+		DECODE_DITHER = 0x200,
+		DECODE_ONEPASS = 0x400,
+		DECODE_NOSMOOTH = 0x800
+	}; 
+
+	int m_nPredictor;
+	int m_nPointTransform;
+	int m_nSmoothing;
+	int m_nQuantize;
+	J_DITHER_MODE m_nDither;
+
+};
+
+#endif
+
+#endif
